"use strict";Object.defineProperty(exports, "__esModule", {value: true});var _index = require('../tokenizer/index');
var _types = require('../tokenizer/types');
var _base = require('../traverser/base');
var _expression = require('../traverser/expression');
var _flow = require('./flow');
var _typescript = require('./typescript');

/**
 * Common parser code for TypeScript and Flow.
 */

// An apparent conditional expression could actually be an optional parameter in an arrow function.
 function typedParseConditional(noIn, startPos) {
  // only do the expensive clone if there is a question mark
  // and if we come from inside parens
  if (!_index.match.call(void 0, _types.TokenType.question)) {
    _expression.baseParseConditional.call(void 0, noIn, startPos);
    return;
  }

  const snapshot = _base.state.snapshot();
  try {
    _expression.baseParseConditional.call(void 0, noIn, startPos);
    return;
  } catch (err) {
    if (!(err instanceof SyntaxError)) {
      // istanbul ignore next: no such error is expected
      throw err;
    }
    _base.state.restoreFromSnapshot(snapshot);
  }
} exports.typedParseConditional = typedParseConditional;

// Note: These "type casts" are *not* valid TS expressions.
// But we parse them here and change them when completing the arrow function.
 function typedParseParenItem() {
  if (_index.eat.call(void 0, _types.TokenType.question)) {
    _base.state.tokens[_base.state.tokens.length - 1].isType = true;
  }
  if (_index.match.call(void 0, _types.TokenType.colon)) {
    if (_base.isTypeScriptEnabled) {
      _typescript.tsParseTypeAnnotation.call(void 0, );
    } else if (_base.isFlowEnabled) {
      _flow.flowParseTypeAnnotation.call(void 0, );
    }
  }
} exports.typedParseParenItem = typedParseParenItem;
